# Do NOT edit this file!
# It was generated by IdlC class idl.json.python.ProxyAsnVisitor.

#
# Section generated from "/home/builds/gitlab/builds/1da4124e/0/gitlab/main/firmware/mkdist/tmp/build-emx-ecx-final/install_root/share/idl/HardwareHealth.idl"
#

import raritan.rpc
from raritan.rpc import Interface, Structure, ValueObject, Enumeration, typecheck, DecodeException
import raritan.rpc.fitness

import raritan.rpc.idl


# interface
class HardwareHealth(Interface):
    idlType = "fitness.HardwareHealth:1.0.0"

    FAILURE_TYPE_NETWORK_DEVICE_NOT_DETECTED = 1

    FAILURE_TYPE_I2C_BUS_STUCK = 2

    FAILURE_TYPE_SLAVE_CTRL_NOT_REACHABLE = 3

    FAILURE_TYPE_SLAVE_CTRL_MALFUNCTION = 4

    FAILURE_TYPE_OUTLET_POWER_STATE_INCONSISTENT = 5

    # structure
    class Failure(Structure):
        idlType = "fitness.HardwareHealth.Failure:1.0.0"
        elements = ["componentId", "type", "description", "isAsserted", "lastAssertTimeStamp", "lastDeassertTimeStamp", "assertCount"]

        def __init__(self, componentId, type, description, isAsserted, lastAssertTimeStamp, lastDeassertTimeStamp, assertCount):
            typecheck.is_string(componentId, AssertionError)
            typecheck.is_int(type, AssertionError)
            typecheck.is_string(description, AssertionError)
            typecheck.is_bool(isAsserted, AssertionError)
            typecheck.is_time(lastAssertTimeStamp, AssertionError)
            typecheck.is_time(lastDeassertTimeStamp, AssertionError)
            typecheck.is_int(assertCount, AssertionError)

            self.componentId = componentId
            self.type = type
            self.description = description
            self.isAsserted = isAsserted
            self.lastAssertTimeStamp = lastAssertTimeStamp
            self.lastDeassertTimeStamp = lastDeassertTimeStamp
            self.assertCount = assertCount

        @classmethod
        def decode(cls, json, agent):
            obj = cls(
                componentId = json['componentId'],
                type = json['type'],
                description = json['description'],
                isAsserted = json['isAsserted'],
                lastAssertTimeStamp = raritan.rpc.Time.decode(json['lastAssertTimeStamp']),
                lastDeassertTimeStamp = raritan.rpc.Time.decode(json['lastDeassertTimeStamp']),
                assertCount = json['assertCount'],
            )
            return obj

        def encode(self):
            json = {}
            json['componentId'] = self.componentId
            json['type'] = self.type
            json['description'] = self.description
            json['isAsserted'] = self.isAsserted
            json['lastAssertTimeStamp'] = raritan.rpc.Time.encode(self.lastAssertTimeStamp)
            json['lastDeassertTimeStamp'] = raritan.rpc.Time.encode(self.lastDeassertTimeStamp)
            json['assertCount'] = self.assertCount
            return json

    # value object
    class FailureStatusChangedEvent(raritan.rpc.idl.Event):
        idlType = "fitness.HardwareHealth.FailureStatusChangedEvent:1.0.0"

        def __init__(self, componentId, failureType, isAsserted, source):
            super(raritan.rpc.fitness.HardwareHealth.FailureStatusChangedEvent, self).__init__(source)
            typecheck.is_string(componentId, AssertionError)
            typecheck.is_int(failureType, AssertionError)
            typecheck.is_bool(isAsserted, AssertionError)

            self.componentId = componentId
            self.failureType = failureType
            self.isAsserted = isAsserted

        def encode(self):
            json = super(raritan.rpc.fitness.HardwareHealth.FailureStatusChangedEvent, self).encode()
            json['componentId'] = self.componentId
            json['failureType'] = self.failureType
            json['isAsserted'] = self.isAsserted
            return json

        @classmethod
        def decode(cls, json, agent):
            obj = cls(
                componentId = json['componentId'],
                failureType = json['failureType'],
                isAsserted = json['isAsserted'],
                # for idl.Event
                source = Interface.decode(json['source'], agent),
            )
            return obj

        def listElements(self):
            elements = ["componentId", "failureType", "isAsserted"]
            elements = elements + super(raritan.rpc.fitness.HardwareHealth.FailureStatusChangedEvent, self).listElements()
            return elements

    class _getFailures(Interface.Method):
        name = 'getFailures'

        @staticmethod
        def encode():
            args = {}
            return args

        @staticmethod
        def decode(rsp, agent):
            _ret_ = [raritan.rpc.fitness.HardwareHealth.Failure.decode(x0, agent) for x0 in rsp['_ret_']]
            for x0 in _ret_:
                typecheck.is_struct(x0, raritan.rpc.fitness.HardwareHealth.Failure, DecodeException)
            return _ret_
    def __init__(self, target, agent):
        super(HardwareHealth, self).__init__(target, agent)
        self.getFailures = HardwareHealth._getFailures(self)
